#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/time.h>
#include "autoant.h"


FILE *fd;

int16_t read_byte(void) { return (int16_t)fgetc(fd); }
void myseek(int offset) { fseek(fd, offset, SEEK_SET); }

void send_ant(uint8_t *c) {
  int i;
  int l=autoant_antlen(c);
  printf("Sending Ant ");
  for (i=0; i<l; i++) {
    printf("%02x ",c[i]);
  }
  printf("\n");
}

uint8_t *receive_ant(int timeout) {
  printf("Waiting for message %.3f sec\n",(float)timeout/1000.0);
  return NULL;
}

void write_message(char *message) {
  printf("%s",message);
}

void warn_message(int warnno, int linenumber, int pos) {
    printf("At line %d byte %d : %s\n",
           linenumber, pos,
           autoant_interpret_warning(warnno));
}

uint16_t get_milliseconds(void) {

  struct timeval tv;
  gettimeofday(&tv,NULL);

  uint64_t t=tv.tv_sec*1000;
  t+=tv.tv_usec/1000;

  return t & 0xffff;
}

autoant_ops_t ops={
  .receive_ant_message=receive_ant,
  .get_char=read_byte,
  .seek=myseek,
  .send_ant_message=send_ant,
  .write=write_message,
  .warn=warn_message,
  .get_milliseconds=get_milliseconds
};

int main(int argc, char *argv[]) {
  switch (argc) {
  case 1:
    printf("%s -- pretend to play autoant scripts\n",argv[0]);
    printf("\nUse like this:\n");
    printf("   %s scriptname.ants\n",argv[0]);
    printf("\nSend bugs to mark@quarq.us\n\n");
    break;
  case 2:
    fd=fopen(argv[1],"r");
    if (!fd) { perror("Opening file"); return errno; }
    return autoant_exec(&ops);
    break;
  default:
    printf("too many args\n");
  }
  return 0;

}
